<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title> MobiDoc | Appointments </title>
    <link rel="stylesheet" href="styles/Nav_bar.css">

    <link rel="apple-touch-icon" sizes="180x180" href="../favicon/apple-touch-icon.png">
    <link rel="icon" type="image/png" sizes="32x32" href="../favicon/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="../favicon/favicon-16x16.png">
    <link rel="manifest" href="../favicon/site.webmanifest">

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css"/>

    <!-- The core Firebase JS SDK is always required and must be listed first -->
    <script src="https://www.gstatic.com/firebasejs/8.6.1/firebase.js"></script>
    <script src="https://www.gstatic.com/firebasejs/8.6.1/firebase-app.js"></script>
    <script src="https://www.gstatic.com/firebasejs/8.6.1/firebase-auth.js"></script>
    <script src="https://www.gstatic.com/firebasejs/8.6.1/firebase-database.js"></script>
    <script src="https://www.gstatic.com/firebasejs/8.6.1/firebase-analytics.js"></script>
    <link type="text/css" rel="stylesheet" href="https://www.gstatic.com/firebasejs/ui/4.8.0/firebase-ui-auth.css" />
    <link rel="stylesheet" href="./styles/appointments.css">

</head>
<body>



<!-- for the nav bar -->
<div class="wrapper">
    <nav>
        <input type="checkbox" id="show-search">
        <input type="checkbox" id="show-menu">
        <label for="show-menu" class="menu-icon"><i class="fas fa-bars"></i></label>
        <div class="content">
            <div class="logo"><a href="#">MobiDoc</a></div>
            <ul class="links">
                <li><a href="home.html">Home</a></li>
                <li>
                    <a href="profile.html" class="desktop-link">Profile</a>
                    <input type="checkbox" id="show-services">
                    <label for="show-services">Profile</label>
                </li>
                <li><a href="Appointments.html">Accept Appointments</a></li>
                <li><a href="AppointmentTypes/PendingAppointments.html">Reject Appointments</a></li>
                <li><a href="consultations.html">Complete Appointment</a></li>
                <li>
                    <a href="#" class="desktop-link" style="padding-left: 50px">Appointments</a>
                    <input type="checkbox" id="show-features">
                    <label for="show-features">Appointments</label>
                    <ul>
                        <li><a style="padding-left: 60px" href="AppointmentTypes/RejectedAppointments.html">Rejected Appointments</a></li>
                        <li><a style="padding-left: 60px" href="AppointmentTypes/PendingAppointments.html">Pending Appointments</a></li>
                        <li><a style="padding-left: 60px" href="AppointmentTypes/CompletedAppointments.html">Completed Appointments</a></li>
                    </ul>
                </li>
            </ul>
        </div>
    </nav>
</div>
<!-- end of the nav bar -->
<div style="padding-bottom: 200px"></div>
<!--<button onclick="testing1()">Add</button>-->

<dl id="appList" style="position: relative"></dl> <!-- refers to the space underneath the nav bar that contains all the appointments -->
<!-- links this project to firebase -->

<script>

    let firebaseConfig = {
        apiKey: "AIzaSyB-ckD1wmZWj5c7RQIOyBvwFmQApBfEEMU",
        authDomain: "mobidoc-6a3ac.firebaseapp.com",
        databaseURL: "https://mobidoc-6a3ac-default-rtdb.firebaseio.com/",
        projectId: "mobidoc-6a3ac",
        storageBucket: "mobidoc-6a3ac.appspot.com",
        messagingSenderId: "311373483549",
        appId: "1:311373483549:web:3c840b29b14029ac4680f4",
        measurementId: "G-JFPKMPTGZ5"
    };
    // Initialize Firebase
    firebase.initializeApp(firebaseConfig);

</script>
<!--<button onclick="AddAppointments()">Add</button>-->

</body>
<!--moved body tag from bottom of page to here-->

<!--popup for accepting a appointment request -->
<div id="accept_app_popup" class="popup">
    <div class="popup-content">
        <div class="popup-header">
            <h2 style="text-align:center">Accept the request?</h2>
            <span class="popup-close">&times;</span>
        </div>
        <div class="popup-body">
            <p> Click on the button below to accept the appointment request</p>
        </div>
        <div class="popup-footer">
            <button class=b" id="accept_app_btn"> Accept Appointment </button>
            <p id = "error" class = "error"></p>
        </div>
    </div>
</div>

<script>
    // function testing1() {
    //     let database = firebase.database();
    //     let ref = database.ref().child('Appointments');
    //     ref.child("b58UY3yvui7dfgdf65uh52asef2278").update({
    //         "appointment_Cost": "",
    //         "date_for_appointment": "15/11/2021",
    //         "doctorUid": "mbcFUqwFCHV0HnrfX3vxUbXfsqs2",
    //         "doctor_Name": "Arty",
    //         "notes": "",
    //         "patientUid": "XNuD7rqFa3NFeaJkfTYjMC1szBv1",
    //         "patient_Name": "Moseki",
    //         "reason_for_appointment": "Throat is sore",
    //         "status": "pending",
    //         "time_for_appointment": "14:30"
    //     });
    // }

    let user_id;


    // Appointment list
    let appList = document.getElementById("appList");
    firebase.auth().onAuthStateChanged(function (user) {
        if (user) {
            user_id = user.uid;
            getAppointmentDetails(user.uid);
        } else {
            window.location.href = "../index.html"; // redirects the user to the log in page
        }
    });

    const getAppointmentDetails = (uid) => {
        let database = firebase.database();
        let ref = database.ref().child('Appointments');
        ref.orderByKey().once("value",snapshot => {
            if (snapshot.exists()) {
                snapshot.forEach(function (childSnapshot) {
                    let id_app = childSnapshot.key;
                    let app = childSnapshot.val();

                    if (uid === app.doctorUid && app.status === "pending") {
                        console.log(id_app);

                        let label = "<span class='pending'>" + app.status + "</span>"; // only displays the pending appointments

                        appList.innerHTML +=
                            "<div class = 'card'>" +
                            label +
                            "<h2>Appointment with " + app.patient_Name + "</h2>" +
                            "<p id='app_id' style='display:none;'>" + app.id + "</p>" +
                            "<p>" + app.date_for_appointment + " - " + app.time_for_appointment + "</p>" +
                            "<table>" +
                            "<tr>" +
                            "<th>Reason for appointment: </th>" +
                            "<td>" + app.reason_for_appointment + "</td>" +
                            "</br>"+
                            "<button class ='b' id='" + id_app + "' onClick='openAcceptAppPopup(this.id)'> Accept </button>" +
                            "</tr>" +
                            "</table>"
                            +"</div>"
                            +"<br/>"
                        ;
                    }
                });
            }
        });
    }

    function updateAcceptAppointment(appID) {
        let database = firebase.database();
        let ref = database.ref().child('Appointments');
        ref.child(appID).update({"status":"accepted"});

        let popup = document.getElementById("accept_app_popup");
        popup.style.display = "none"; // edited this then the popup disappears off screen after clicking accept button
    }

    function acceptAppointment(appID) {
        console.log(appID);
        updateAcceptAppointment(appID);
    }

    function openAcceptAppPopup(appID) {
        let popup = document.getElementById("accept_app_popup");
        let close = document.getElementsByClassName("popup-close")[0];

        let button = document.getElementById("accept_app_btn");
        button.addEventListener('click', function() {
            acceptAppointment(appID);
        })

        popup.style.display = "block";//opens popup

        //closes popup if user clicks close (little cross upper right corner) or outside popup
        close.onclick = function() {
            popup.style.display = "none";
        }
        window.onclick = function(event) {
            if (event.target === popup) {
                popup.style.display = "none";
            }
        }
    }

    function updatemenu() {
        if (document.getElementById('responsive-menu').checked === true) {
            document.getElementById('menu').style.borderBottomRightRadius = '0';
            document.getElementById('menu').style.borderBottomLeftRadius = '0';
        }
        else{
            document.getElementById('menu').style.borderRadius = '0px';
        }
    }
</script>

<!-- links the js file to the html file under Appointments-->
<script src = "scripts/Appointments.js"></script>

</body>
</html>
</html>